import * as Vuex from 'vuex';
import Model from './Model';
import { Entity } from './Module';
export default class Database {
    /**
     * The list of entities to be registered to Vuex Store.
     */
    entities: Entity[];
    /**
     * Registers a model to the entity list.
     */
    register(model: typeof Model, module: Vuex.Module<any, any>): void;
    /**
     * Generate Vuex Module from registered entities.
     */
    modules(namespace: string): Vuex.Module<any, any>;
    /**
     * Register namespace to the all regitsered model.
     */
    registerNamespace(namespace: string): void;
}
