"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("./support/lodash");
var Module_1 = require("./Module");
var Database = /** @class */ (function () {
    function Database() {
        /**
         * The list of entities to be registered to Vuex Store.
         */
        this.entities = [];
    }
    /**
     * Registers a model to the entity list.
     */
    Database.prototype.register = function (model, module) {
        this.entities.push({ model: model, module: module });
    };
    /**
     * Generate Vuex Module from registered entities.
     */
    Database.prototype.modules = function (namespace) {
        return Module_1.default.create(namespace, this.entities);
    };
    /**
     * Register namespace to the all regitsered model.
     */
    Database.prototype.registerNamespace = function (namespace) {
        _.forEach(this.entities, function (entity) { entity.model.connection = namespace; });
    };
    return Database;
}());
exports.default = Database;
//# sourceMappingURL=Database.js.map