import * as Vuex from 'vuex';
import Model from './Model';
export interface Entity {
    model: typeof Model;
    module: Vuex.Module<any, any>;
}
export interface State {
    name: string;
    [key: string]: any;
}
export interface EntityState {
    $connection: string;
    $name: string;
    $primaryKey: string;
    data: {
        [key: string]: any;
    };
    [key: string]: any;
}
export default class Module {
    /**
     * The default state. This state will be merged with additional
     * entity's state if it has any.
     */
    static state: EntityState;
    /**
     * Creates module from the given entities.
     */
    static create(namespace: string, entities: Entity[]): Vuex.Module<any, any>;
    /**
     * Creates module tree to be registered under top level module
     * from the given entities.
     */
    static createTree(tree: any, namespace: string, entities: Entity[]): Vuex.Module<any, any>;
}
