import { schema, Schema as NormalizrSchema } from 'normalizr';
import { Fields } from './Attributes';
import Model from './Model';
export interface Schemas {
    [entity: string]: schema.Entity;
}
export default class Schema {
    /**
     * Create a schema of given model.
     */
    static one(model: typeof Model, schemas?: Schemas): schema.Entity;
    /**
     * Create a array schema of givene model.
     */
    static many(model: typeof Model, schemas?: Schemas): schema.Array;
    /**
     * Create a dfinition from given fields.
     */
    static definition(model: typeof Model, schemas?: Schemas): NormalizrSchema;
    /**
     * Build a definition schema.
     */
    static build(model: typeof Model, fields: Fields, schemas?: Schemas): NormalizrSchema;
}
