"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var normalizr_1 = require("normalizr");
var _ = require("./support/lodash");
var AttrTypes_1 = require("./Attributes/AttrTypes");
var Attributes_1 = require("./Attributes");
var Schema = /** @class */ (function () {
    function Schema() {
    }
    /**
     * Create a schema of given model.
     */
    Schema.one = function (model, schemas) {
        if (schemas === void 0) { schemas = {}; }
        var thisSchema = new normalizr_1.schema.Entity(model.entity, {}, {
            idAttribute: model.primaryKey
        });
        var definition = this.definition(model, __assign({}, schemas, (_a = {}, _a[model.entity] = thisSchema, _a)));
        thisSchema.define(definition);
        return thisSchema;
        var _a;
    };
    /**
     * Create a array schema of givene model.
     */
    Schema.many = function (model, schemas) {
        if (schemas === void 0) { schemas = {}; }
        return new normalizr_1.schema.Array(this.one(model, schemas));
    };
    /**
     * Create a dfinition from given fields.
     */
    Schema.definition = function (model, schemas) {
        if (schemas === void 0) { schemas = {}; }
        return this.build(model, model.fields(), schemas);
    };
    /**
     * Build a definition schema.
     */
    Schema.build = function (model, fields, schemas) {
        var _this = this;
        if (schemas === void 0) { schemas = {}; }
        return _.reduce(fields, function (definition, field, key) {
            if (!Attributes_1.default.isAttribute(field)) {
                definition[key] = _this.build(model, field, schemas);
                return definition;
            }
            if (field.type === AttrTypes_1.default.HasOne || field.type === AttrTypes_1.default.BelongsTo) {
                var relation = model.resolveRelation(field);
                var s = schemas[relation.entity];
                definition[key] = s ? s : _this.one(relation, schemas);
                return definition;
            }
            if (field.type === AttrTypes_1.default.HasMany || field.type === AttrTypes_1.default.HasManyBy) {
                var relation = model.resolveRelation(field);
                var s = schemas[relation.entity];
                definition[key] = s ? new normalizr_1.schema.Array(s) : _this.many(relation, schemas);
                return definition;
            }
            return definition;
        }, {});
    };
    return Schema;
}());
exports.default = Schema;
//# sourceMappingURL=Schema.js.map