import Model from '../Model';
import Database from '../Database';
export default class Connection {
    /**
     * The database instance.
     */
    database: Database;
    /**
     * Creates a connection instance.
     */
    constructor(database: Database);
    /**
     * Returns models in database with name.
     */
    models(): {
        [name: string]: typeof Model;
    };
    /**
     * Find model in database by given name
     */
    model(name: string): typeof Model;
}
