"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("../support/lodash");
var Connection = /** @class */ (function () {
    /**
     * Creates a connection instance.
     */
    function Connection(database) {
        this.database = database;
    }
    /**
     * Returns models in database with name.
     */
    Connection.prototype.models = function () {
        var models = {};
        _.forEach(this.database.entities, function (entity) {
            models[entity.model.entity] = entity.model;
        });
        return models;
    };
    /**
     * Find model in database by given name
     */
    Connection.prototype.model = function (name) {
        return this.models()[name];
    };
    return Connection;
}());
exports.default = Connection;
//# sourceMappingURL=Connection.js.map